/*---------------------------------------------------------------------------*/
/* Logiciel Client FTP.                                                      */
/*---------------------------------------------------------------------------*/
/* Projet  : MyFTP                                     Version  : 0.1.0.0    */
/* Fichier : cnxdlg.cpp                                                      */
/* Auteur  : Fred Cailleau-Lepetit                     Date     : 08/03/2006 */
/* email   : softinthebox@free.fr                      Rvision : 08/03/2006 */
/*---------------------------------------------------------------------------*/
/* Copyright (C) Fred Cailleau-Lepetit 2005-2006                             */
/* Licence GNU General Public License  http://www.fsf.org/copyleft/gpl.html  */
/*---------------------------------------------------------------------------*/
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation (version 2);

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
selon les termes de la Licence Publique Gnrale GNU publie par la
Free Software Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais
SANS AUCUNE GARANTIE, ni explicite ni implicite, y compris
les garanties de commercialisation ou d'adaptation dans un but
spcifique. Reportez-vous  la Licence Publique Gnrale GNU
pour plus de dtails.
*/

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma implementation "cnxdlg.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "cnxdlg.h"

#define ID_HOSTNAME  10401
#define ID_SERVICE   10402
#define ID_USER      10403
#define ID_PASSWORD  10404

wxMyFTPCnxDlg::wxMyFTPCnxDlg(wxWindow* parent, wxWindowID id,
                             const wxString& caption, const wxPoint& pos,
                             const wxSize& size, long style)
{
   Create(parent, id, caption, pos, size, style);
}

bool wxMyFTPCnxDlg::Create(wxWindow* parent, wxWindowID id,
                           const wxString& caption, const wxPoint& pos,
                           const wxSize& size, long style)
{
   m_ctrl_Hostname = NULL;
   m_ctrl_Service = NULL;

   SetExtraStyle(GetExtraStyle()|wxWS_EX_BLOCK_EVENTS);
   wxDialog::Create(parent, id, caption, pos, size, style);

   CreateControls();
   GetSizer()->Fit(this);
   GetSizer()->SetSizeHints(this);
   Centre();

   return TRUE;
}

void wxMyFTPCnxDlg::CreateControls()
{
   wxBoxSizer* Sizer1 = new wxBoxSizer(wxVERTICAL);
   SetSizer(Sizer1);

   wxBoxSizer* Sizer2 = new wxBoxSizer(wxHORIZONTAL);
   Sizer1->Add(Sizer2, 0, wxALIGN_LEFT|wxALL, 5);

   wxBoxSizer* Sizer3 = new wxBoxSizer(wxVERTICAL);
   Sizer2->Add(Sizer3, 0, wxALIGN_CENTER_VERTICAL, 0);

   wxStaticText* Text1 = new wxStaticText(this, wxID_STATIC, _("&Hostname"),
                                          wxDefaultPosition, wxDefaultSize, 0);
   Sizer3->Add(Text1, 0, wxALIGN_LEFT|wxALL|wxADJUST_MINSIZE, 5);

   m_ctrl_Hostname = new wxTextCtrl(this, ID_HOSTNAME, wxEmptyString,
                                    wxDefaultPosition, wxSize(250, -1), 0);
   Sizer3->Add(m_ctrl_Hostname, 0, wxALIGN_LEFT|wxALL, 5);

   wxBoxSizer* Sizer4 = new wxBoxSizer(wxVERTICAL);
   Sizer2->Add(Sizer4, 0, wxALIGN_CENTER_VERTICAL, 0);

   wxStaticText* Text2 = new wxStaticText(this, wxID_STATIC, _("&Service"),
                                          wxDefaultPosition, wxDefaultSize, 0);
   Sizer4->Add(Text2, 0, wxALIGN_LEFT|wxALL|wxADJUST_MINSIZE, 5);

   m_ctrl_Service = new wxTextCtrl(this, ID_SERVICE, wxEmptyString,
                                   wxDefaultPosition, wxSize(50, -1), 0);
   Sizer4->Add(m_ctrl_Service, 0, wxALIGN_LEFT|wxALL, 5);

   wxBoxSizer* Sizer5 = new wxBoxSizer(wxHORIZONTAL);
   Sizer1->Add(Sizer5, 0, wxALIGN_LEFT|wxALL, 5);

   wxBoxSizer* Sizer6 = new wxBoxSizer(wxVERTICAL);
   Sizer5->Add(Sizer6, 0, wxALIGN_CENTER_VERTICAL, 0);

   wxStaticText* Text3 = new wxStaticText(this, wxID_STATIC, _("&User name"),
                                          wxDefaultPosition, wxDefaultSize, 0);
   Sizer6->Add(Text3, 0, wxALIGN_LEFT|wxALL|wxADJUST_MINSIZE, 5);

   wxTextCtrl* TextCtrl3 = new wxTextCtrl(this, ID_USER, wxEmptyString,
                                          wxDefaultPosition, wxSize(150, -1), 0);
   Sizer6->Add(TextCtrl3, 0, wxALIGN_LEFT|wxALL, 5);

   wxBoxSizer* Sizer7 = new wxBoxSizer(wxVERTICAL);
   Sizer5->Add(Sizer7, 0, wxALIGN_CENTER_VERTICAL, 0);

   wxStaticText* Text4 = new wxStaticText(this, wxID_STATIC, _("&Password"),
                                          wxDefaultPosition, wxDefaultSize, 0);
   Sizer7->Add(Text4, 0, wxALIGN_LEFT|wxALL|wxADJUST_MINSIZE, 5);

   wxTextCtrl* TextCtrl4 = new wxTextCtrl(this, ID_PASSWORD, wxEmptyString,
                                          wxDefaultPosition, wxSize(150, -1),
                                          wxTE_PASSWORD);
   Sizer7->Add(TextCtrl4, 0, wxALIGN_LEFT|wxALL, 5);

   wxStdDialogButtonSizer* ButtonSizer = new wxStdDialogButtonSizer;

   Sizer1->Add(ButtonSizer, 0, wxALIGN_RIGHT|wxALL, 5);
   wxButton* BtnOk = new wxButton(this, wxID_OK, _("&OK"), wxDefaultPosition,
                                  wxDefaultSize, 0);
   BtnOk->SetDefault();
   ButtonSizer->AddButton(BtnOk);

   wxButton* BtnCancel = new wxButton(this, wxID_CANCEL, _("&Cancel"),
                                      wxDefaultPosition, wxDefaultSize, 0);
   ButtonSizer->AddButton(BtnCancel);
   ButtonSizer->Realize();

   // Set validators
   m_ctrl_Hostname->SetValidator(wxTextValidator(wxFILTER_NONE, &m_Hostname));
   m_ctrl_Service->SetValidator(wxTextValidator(wxFILTER_NUMERIC, &m_Service));
   TextCtrl3->SetValidator(wxTextValidator(wxFILTER_NONE, &m_Username));
   TextCtrl4->SetValidator(wxTextValidator(wxFILTER_NONE, &m_Password));
}

bool wxMyFTPCnxDlg::Validate()
{
   bool ret = wxDialog::Validate();

   if (ret)
   {
      wxString tmp;

      tmp = m_ctrl_Hostname->GetValue();
      if (tmp.IsEmpty())
      {
         wxMessageBox(_("The value of the hostname is compulsory."),
                      _("Error"), wxICON_ERROR|wxOK, this);
         m_ctrl_Hostname->SetFocus();
         ret = false;
      }
      if (ret)
      {
         tmp = m_ctrl_Service->GetValue();
         if (tmp.IsEmpty())
         {
            wxMessageBox(_("The value of the service is compulsory."),
                         _("Error"), wxICON_ERROR|wxOK, this);
            m_ctrl_Service->SetFocus();
            ret = false;
         }
      }
   }

   return ret;
}
