/*---------------------------------------------------------------------------*/
/* Logiciel Client FTP.                                                      */
/*---------------------------------------------------------------------------*/
/* Projet  : MyFTP                                     Version  : 0.1.0.0    */
/* Fichier : cnxdlg.h                                                        */
/* Auteur  : Fred Cailleau-Lepetit                     Date     : 08/03/2006 */
/* email   : softinthebox@free.fr                      Rvision : 08/03/2006 */
/*---------------------------------------------------------------------------*/
/* Copyright (C) Fred Cailleau-Lepetit 2005-2006                             */
/* Licence GNU General Public License  http://www.fsf.org/copyleft/gpl.html  */
/*---------------------------------------------------------------------------*/
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation (version 2).

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
selon les termes de la Licence Publique Gnrale GNU publie par la
Free Software Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais
SANS AUCUNE GARANTIE, ni explicite ni implicite, y compris
les garanties de commercialisation ou d'adaptation dans un but
spcifique. Reportez-vous  la Licence Publique Gnrale GNU
pour plus de dtails.
*/

#ifndef _CNXDLG_H_
#define _CNXDLG_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "cnxdlg.cpp"
#endif
/*---------------------------------------------------------------------------*/
class wxMyFTPCnxDlg: public wxDialog
{
   public:

      wxMyFTPCnxDlg(wxWindow* parent, wxWindowID id = -1,
                    const wxString& caption = _("Connecting to"),
                    const wxPoint& pos = wxDefaultPosition,
                    const wxSize& size = wxDefaultSize,
                    long style = wxDEFAULT_DIALOG_STYLE);

      bool Create(wxWindow* parent, wxWindowID id = -1,
                  const wxString& caption = _("Connecting to"),
                  const wxPoint& pos = wxDefaultPosition,
                  const wxSize& size = wxDefaultSize,
                  long style = wxDEFAULT_DIALOG_STYLE);

      wxString GetHostname() const {return m_Hostname;}
      void SetHostname(wxString value) {m_Hostname = value;}
      wxString GetService() const {return m_Service;}
      void SetService(wxString value) {m_Service = value;}
      wxString GetUsername() const {return m_Username;}
      void SetUsername(wxString value) {m_Username = value;}
      wxString GetPassword() const {return m_Password;}
      void SetPassword(wxString value) {m_Password = value;}

      virtual bool Validate();

   protected:

      void CreateControls();

   private:

      wxTextCtrl* m_ctrl_Hostname;
      wxTextCtrl* m_ctrl_Service;

      wxString m_Hostname;
      wxString m_Service;
      wxString m_Username;
      wxString m_Password;

};
/*---------------------------------------------------------------------------*/
#endif   // _CNXDLG_H_
