/*---------------------------------------------------------------------------*/
/* Logiciel Client FTP.                                                      */
/*---------------------------------------------------------------------------*/
/* Projet  : MyFTP                                     Version  : 0.1.0.0    */
/* Fichier : myftp.cpp                                                       */
/* Auteur  : Fred Cailleau-Lepetit                     Date     : 28/03/2006 */
/* email   : softinthebox@free.fr                      Rvision : 28/03/2006 */
/*---------------------------------------------------------------------------*/
/* Copyright (C) Fred Cailleau-Lepetit 2005-2006                             */
/* Licence GNU General Public License  http://www.fsf.org/copyleft/gpl.html  */
/*---------------------------------------------------------------------------*/
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation (version 2);

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
selon les termes de la Licence Publique Gnrale GNU publie par la
Free Software Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais
SANS AUCUNE GARANTIE, ni explicite ni implicite, y compris
les garanties de commercialisation ou d'adaptation dans un but
spcifique. Reportez-vous  la Licence Publique Gnrale GNU
pour plus de dtails.
*/

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma implementation "myftp.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
   #include <wx/wx.h>
#endif
#include "myftp.h"

IMPLEMENT_DYNAMIC_CLASS(wxMyFTP, wxFTP)

bool wxMyFTP::Connect(wxSockAddress& address, bool wait)
{
   if (address.IsKindOf(CLASSINFO(wxIPaddress)))
   {
      m_Hostname = ((wxIPaddress*)(&address))->Hostname();
      m_Service = ((wxIPaddress*)(&address))->Service();
   }
   return wxFTP::Connect(address, wait);
}

bool wxMyFTP::Connect()
{
   wxIPV4address ipAddress;

   ipAddress.Hostname(m_Hostname);
   ipAddress.Service(m_Service);

   return wxFTP::Connect(ipAddress, false);
}

wxString wxMyFTP::User()
{
   if (m_user == _T("anonymous"))
      return wxEmptyString;
   else
      return m_user;
}

bool wxMyFTP::CdUp()
{
   return wxFTP::DoSimpleCommand(_T("CDUP"));
}

int wxMyFTP::GetFileSize(const wxString& path, const wxString& filename)
{
   int fileSize;

   wxString OldPath = wxFTP::Pwd();   // Sauvegarde du chemin actuel

   wxFTP::ChDir(path);  // Changement du chemin
   fileSize = wxFTP::GetFileSize(filename);
   wxFTP::ChDir(OldPath);  // Restauration du chemin

   return fileSize;
}

wxOutputStream* wxMyFTP::GetOutputStream(const wxString& path,
                                         const wxString& filename, bool ascii)
{
   wxOutputStream* stream;

   wxString OldPath = wxFTP::Pwd();   // Sauvegarde du chemin actuel

   wxFTP::ChDir(path);  // Changement du chemin
   if (ascii)
      SetAscii();       // Mode de transfert Ascii
   else
      SetBinary();      // Mode de transfert Binaire
   stream = wxFTP::GetOutputStream(filename);
   m_LastOpenStreamResult = wxFTP::GetLastResult();
   wxFTP::ChDir(OldPath);  // Restauration du chemin

   return stream;
}

wxInputStream* wxMyFTP::GetInputStream(const wxString& path,
                                       const wxString& filename, bool ascii)
{
   wxInputStream* stream;

   wxString OldPath = wxFTP::Pwd();   // Sauvegarde du chemin actuel

   wxFTP::ChDir(path);  // Changement du chemin
   if (ascii)
      SetAscii();       // Mode de transfert Ascii
   else
      SetBinary();      // Mode de transfert Binaire
   stream = wxFTP::GetInputStream(filename);
   m_LastOpenStreamResult = wxFTP::GetLastResult();
   wxFTP::ChDir(OldPath);  // Restauration du chemin

   return stream;
}
