/*---------------------------------------------------------------------------*/
/* Logiciel Client FTP.                                                      */
/*---------------------------------------------------------------------------*/
/* Projet  : MyFTP                                     Version  : 0.1.0.0    */
/* Fichier : myftp.h                                                         */
/* Auteur  : Fred Cailleau-Lepetit                     Date     : 28/03/2006 */
/* email   : softinthebox@free.fr                      Rvision : 29/03/2006 */
/*---------------------------------------------------------------------------*/
/* Copyright (C) Fred Cailleau-Lepetit 2005-2006                             */
/* Licence GNU General Public License  http://www.fsf.org/copyleft/gpl.html  */
/*---------------------------------------------------------------------------*/
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation (version 2).

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
selon les termes de la Licence Publique Gnrale GNU publie par la
Free Software Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais
SANS AUCUNE GARANTIE, ni explicite ni implicite, y compris
les garanties de commercialisation ou d'adaptation dans un but
spcifique. Reportez-vous  la Licence Publique Gnrale GNU
pour plus de dtails.
*/

#ifndef _MYFTP_H_
#define _MYFTP_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "myftp.cpp"
#endif
#include <wx/protocol/ftp.h>

class wxMyFTP : public wxFTP
{
   public:

      wxMyFTP(const wxString& hostname, unsigned short service) : wxFTP()
         {m_Hostname = hostname; m_Service = service;}

      bool Connect(wxSockAddress& address, bool wait = true);
      bool Connect();

      unsigned short Service(){return m_Service;}
      wxString Hostname(){return m_Hostname;}
      wxString User();

      bool CdUp();
      int GetFileSize(const wxString& path, const wxString& filename);
      wxOutputStream* GetOutputStream(const wxString& path,
                                      const wxString& filename, bool ascii);
      wxInputStream* GetInputStream(const wxString& path,
                                    const wxString& filename, bool ascii);
      const wxString& GetLastOpenStreamResult(){return m_LastOpenStreamResult;}

      bool OnStreaming(){return m_streaming;}

      wxCriticalSection m_ftp_critsect;

   private:

      wxString m_LastOpenStreamResult;
      wxString m_Hostname;
      unsigned short m_Service;

      wxMyFTP() : wxFTP(){}

   DECLARE_DYNAMIC_CLASS_NO_COPY(wxMyFTP)
};

#endif   // _MYFTP_H_
