/*---------------------------------------------------------------------------*/
/* Logiciel Client FTP.                                                      */
/*---------------------------------------------------------------------------*/
/* Projet  : MyFTP                                     Version  : 0.1.0.0    */
/* Fichier : myftpapp.h                                                      */
/* Auteur  : Fred Cailleau-Lepetit                     Date     : 27/02/2006 */
/* email   : softinthebox@free.fr                      Rvision : 03/04/2006 */
/*---------------------------------------------------------------------------*/
/* Copyright (C) Fred Cailleau-Lepetit 2005-2006                             */
/* Licence GNU General Public License  http://www.fsf.org/copyleft/gpl.html  */
/*---------------------------------------------------------------------------*/
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation (version 2).

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
selon les termes de la Licence Publique Gnrale GNU publie par la
Free Software Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais
SANS AUCUNE GARANTIE, ni explicite ni implicite, y compris
les garanties de commercialisation ou d'adaptation dans un but
spcifique. Reportez-vous  la Licence Publique Gnrale GNU
pour plus de dtails.
*/
#ifndef _MYFTPAPP_H_
#define _MYFTPAPP_H_

#if defined(__GNUG__) && !defined(__APPLE__)
#pragma interface "myftpapp.cpp"
#endif

enum wxFtpJobs {mfjNone, mfjRefresh, mfjChangeDir, mfjCreateDir,
                mfjRemoveDir, mfjDelete, mfjRename, mfjDisconnect};

class wxJob
{
   public:

      wxJob() : jobsFtp(mfjNone){}
      wxJob(wxFtpJobs action, const wxString& str1, const wxString& str2) :
         jobsFtp(action){jobsString1 = str1; jobsString2 = str2;}

      wxFtpJobs jobsFtp;
      wxString jobsString1;
      wxString jobsString2;
};

class wxMyFTP;
class wxThread;

WX_DEFINE_ARRAY_PTR(wxMyFTP*, wxArrayFTP);
WX_DEFINE_ARRAY_PTR(wxThread*, wxArrayThread);
WX_DEFINE_ARRAY_PTR(wxJob*, wxArrayJob);

class wxMyFTPApp: public wxApp
{
   public:

      wxCriticalSection m_array_job_critsect;
      wxArrayJob m_jobs;

      wxCriticalSection m_array_ftp_critsect;
      wxArrayFTP m_ftps;

      wxCriticalSection m_data_critsect;
      wxString remotePath;
      bool bConnected;

      wxCriticalSection m_array_thread_critsect;
      wxArrayThread m_threads;
      wxSemaphore m_semAllDone;
      bool m_waitingUntilAllDone;

      wxString GetRemotePath();
      bool GetConnected();

      wxMyFTPApp();

      virtual bool OnInit();

      wxMyFTP* CreateFTP(const wxString& hostname, unsigned short service,
                         const wxString& user, const wxString& password,
                         bool passive);

      wxOutputStream* GetOutputStream(wxMyFTP* ftp, const wxString& path,
                                      const wxString& filename, bool ascii);
      wxInputStream* GetInputStream(wxMyFTP* ftp, const wxString& path,
                                    const wxString& filename, bool ascii);

      void Using(wxMyFTP* ftp);
      bool Used(wxMyFTP* ftp);

      bool CurrentOnStreaming();

   private:

      wxCriticalSection m_used_critsect;
      wxMyFTP* m_UsedFTP;

      wxMyFTP* GetFTP(const wxString& hostname, unsigned short service,
                      const wxString& user);

};

DECLARE_APP(wxMyFTPApp)

extern int wxCALLBACK CompareList(long item1, long item2, long sortData);

#endif   // _MYFTPAPP_H_
