/*---------------------------------------------------------------------------*/
/* Logiciel Client FTP.                                                      */
/*---------------------------------------------------------------------------*/
/* Projet  : MyFTP                                     Version  : 0.1.0.0    */
/* Fichier : myftpframe.cpp                                                  */
/* Auteur  : Fred Cailleau-Lepetit                     Date     : 28/02/2006 */
/* email   : softinthebox@free.fr                      Rvision : 28/02/2006 */
/*---------------------------------------------------------------------------*/
/* Copyright (C) Fred Cailleau-Lepetit 2005-2006                             */
/* Licence GNU General Public License  http://www.fsf.org/copyleft/gpl.html  */
/*---------------------------------------------------------------------------*/
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation (version 2);

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
selon les termes de la Licence Publique Gnrale GNU publie par la
Free Software Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais
SANS AUCUNE GARANTIE, ni explicite ni implicite, y compris
les garanties de commercialisation ou d'adaptation dans un but
spcifique. Reportez-vous  la Licence Publique Gnrale GNU
pour plus de dtails.
*/
#if defined(__GNUG__) && !defined(__APPLE__)
#pragma implementation "myftpframe.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include "myftpframe.h"

// Control Id
#define ID_STATUSBAR          10102

// Menu Item Id
#define ID_MNU_CONNECTING     10201
#define ID_MNU_DISCONNECTING  10202
#define ID_MNU_QUIT           10203

#define ID_MNU_UPLOAD         10301
#define ID_MNU_CHANGE_LOCAL   10302
#define ID_MNU_CREATE_LOCAL   10303
#define ID_MNU_DEL_LOCAL      10304
#define ID_MNU_REFRESH_LOCAL  10305

#define ID_MNU_DOWNLOAD       10401
#define ID_MNU_CREATE_REMOTE  10402
#define ID_MNU_DEL_REMOTE     10403
#define ID_MNU_RENAME_REMOTE  10404
#define ID_MNU_REFRESH_REMOTE 10405

#define ID_MNU_ABOUT          10501

wxMyFTPFrame::wxMyFTPFrame(wxWindow* parent, wxWindowID id, const wxString& caption,
                           const wxPoint& pos, const wxSize& size, long style)
{
   Create(parent, id, caption, pos, size, style);
}

wxMyFTPFrame::~wxMyFTPFrame()
{
}

bool wxMyFTPFrame::Create(wxWindow* parent, wxWindowID id, const wxString& caption,
                        const wxPoint& pos, const wxSize& size, long style)
{
   wxFrame::Create(parent, id, caption, pos, size, style);
   CreateMenu();

   return TRUE;
}

void wxMyFTPFrame::CreateMenu()
{
   wxMenuBar* menuBar = new wxMenuBar;
   
   m_MnuFile = new wxMenu;
   m_MnuFile->Append(ID_MNU_CONNECTING, _("&Connecting..."));
   m_MnuFile->Append(ID_MNU_DISCONNECTING, _("&Disconnecting"));
   m_MnuFile->AppendSeparator();
   m_MnuFile->Append(ID_MNU_QUIT, _("&Quit"));
   menuBar->Append(m_MnuFile, _("&File"));
   
   m_MnuLocal = new wxMenu;
   m_MnuLocal->Append(ID_MNU_UPLOAD, _("&Upload files"));
   m_MnuLocal->Append(ID_MNU_CHANGE_LOCAL, _("&Change directory..."));
   m_MnuLocal->Append(ID_MNU_CREATE_LOCAL, _("Create &directory..."));
   m_MnuLocal->Append(ID_MNU_DEL_LOCAL, _("&Erase files"));
   m_MnuLocal->Append(ID_MNU_REFRESH_LOCAL, _("&Refresh"));
   menuBar->Append(m_MnuLocal, _("Local"));
   
   m_MnuRemote = new wxMenu;
   m_MnuRemote->Append(ID_MNU_DOWNLOAD, _("&Download files"));
   m_MnuRemote->Append(ID_MNU_CREATE_REMOTE, _("&Create directory..."));
   m_MnuRemote->Append(ID_MNU_DEL_REMOTE, _("&Erase files"));
   m_MnuRemote->Append(ID_MNU_RENAME_REMOTE, _("Rename file..."));
   m_MnuRemote->Append(ID_MNU_REFRESH_REMOTE, _("&Refresh"));
   menuBar->Append(m_MnuRemote, _("Remote"));
   
   wxMenu* MnuHelp = new wxMenu;
   MnuHelp->Append(ID_MNU_ABOUT, _("&About..."));
   menuBar->Append(MnuHelp, _("&Help"));
   
   SetMenuBar(menuBar);

   wxStatusBar* StatusBar = new wxStatusBar(this, ID_STATUSBAR,
                                            wxST_SIZEGRIP|wxNO_BORDER);
   StatusBar->SetFieldsCount(3);
   SetStatusBar(StatusBar);
}
